class ImageSet {
  ArrayList<AnchorImage> aImages; 
  boolean selected = false;
  String folderName;
  String absFolderName;
  int drawOrder = -1;

  ImageSet( List<File> files, String _folder ) {
    aImages = new ArrayList<AnchorImage>();
    folderName = _folder;
    // List<File> files=  loadImagesFolder(_folder);
    for (int i = 0; i < files.size(); i++) {
      aImages.add(new AnchorImage( loadImage( files.get(i).getAbsolutePath() ) ) );
    }
    setBrowser.updateMenu();
  }
}

class AnchorImage {
  ArrayList<Joint> joints; 
  PImage img;
  int thumbW, thumbH;
  boolean selected = false;
  int posx = 0;
  int posy = 0;
  int drawOrder;

  AnchorImage(PImage _img) {
    img = _img;
    joints = new ArrayList<Joint>();
  }

  AnchorImage(PImage _img , int x , int y) {
    img = _img;
    posx = x;
    posy = y;
  }

  int hasJoint(int _id) {
    int has = -1;
    for (Joint a : joints) {
      if (a.id == _id) {
        has = joints.indexOf(a);
        break;
      }
    }
    return has;
  }

  int fitImageWidth(int new_width) {
    int w, h, new_height;
    w = img.width;
    h = img.height;
    new_height = h;
    float ratio = w/h;

    if ( w > new_width ) {
      new_height = (new_width * h) / w;
    }

    //if (new_height > bound_height) {
    //  //scale height to fit instead
    //  new_height = bound_height;
    //  //scale width to maintain aspect ratio
    //  new_width = (new_height * original_width) / original_height;
    //}
    return new_height;
  }
}

class Anchor {
  String name;
  int x;
  int y;
  Anchor(int _x, int _y, String _name) {
    name = _name;
    x=_x;
    y=_y;
  }
}
