class CustomList extends Controller<CustomList> {
  ArrayList<ImageSet> setImages; 
  float pos, npos;
  int itemHeight = 50;
  int scrollerLength = 40;
  PGraphics menu;
  boolean updateMenu;
  int totalHeight=0;
  int w, h;
  int btSize = 50;

  CustomList(ControlP5 c, String theName, int theWidth, int theHeight, ArrayList<ImageSet> _setImages) {
    super( c, theName, 0, 0, theWidth, theHeight );
    c.register( this );
    w = theWidth;
    setImages = _setImages;
    updateHeight();
    menu = createGraphics(getWidth(), getHeight() );
    setView(new ControllerView<CustomList>() {
      public void display(PGraphics pg, CustomList t ) {
        if (updateMenu) {
          updateMenu();
        }
        if (inside() ) {
          menu.beginDraw();
          //int len = -(itemHeight * items.size()) + getHeight();
          //int ty = int(map(pos, len, 0, getHeight() - scrollerLength - 2, 2 ) );
          // menu.rect(getWidth()-4, ty, 4, scrollerLength );
          menu.endDraw();
        }
        pg.image(menu, 0, 0);
      }
    }
    );
    updateMenu();
  }

  void updateMenu() {
    int len = -(totalHeight) + getHeight();
    npos = constrain(npos, len, 0);
    if (totalHeight < getHeight() ) {
      pos = 0;
    } else {
      pos += (npos - pos) * 0.1;
    }
    if (inside() && setImages.size() > 0) {
      int len2 = itemHeight * setImages.size();
      int index = int( map( getPointer().y() - pos, 0, len2, 0, setImages.size() ) ) ;
      drawNormal();
      if (index < setImages.size() ) {
        drawOver(index);
      }
    } else {
      drawNormal();
    }
    updateMenu = abs(npos-pos)>0.01 ? true:false;
  }

  void drawOver(int index) {
    int mX = getPointer().x();
    menu.beginDraw();
    menu.pushMatrix();
    menu.translate( 0, itemHeight *index );
    menu.pushMatrix();
    menu.textFont(iconFont);
    menu.textSize(21);
    menu.textAlign(CENTER, CENTER);
    if ( mX < w-btSize) {
      menu.fill(0, 50);
      menu.text("\ue5cd", w-btSize/2, btSize/2-2);
      //  menu.text("\ue838", w-btSize-btSize/2, btSize/2-2);
    } /*else if ( mX >= w-2*btSize && mX <w-btSize) {
     menu.fill(126, 191, 41);
     menu.rect(w-2*btSize, 0, btSize, itemHeight-1);
     menu.fill(255);
     menu.text("\ue838", w-btSize-btSize/2, btSize/2-2);
     menu.fill(0, 50);
     menu.text("\ue5cd", w-btSize/2, btSize/2-2);
     }*/
    else {
      menu.fill(255, 0, 0);
      menu.rect(w-btSize, 0, btSize, itemHeight-1);
      menu.fill(255);
      menu.text("\ue5cd", w-btSize/2, btSize/2-2);
    }
    //menu.fill(230);
    //menu.rect(w-100, 0, 50, itemHeight-1);
    //menu.fill(200);
    //menu.textSize(24);
    //menu.text("▲", w-82, 32); 
    menu.popMatrix();
    menu.popMatrix();
    menu.endDraw();
  }

  void drawNormal() {
    menu.beginDraw();
    menu.pushMatrix();
    menu.translate( 0, pos );
    menu.pushMatrix();
    menu.noStroke();
    menu.background(240);
    menu.textAlign(LEFT);
    for (ImageSet a : setImages) {
      if (a.selected) {
        menu.fill(255, 255, 155);
      } else {
        menu.fill(255);
      }
      menu.rect(0, 0, w, itemHeight-1);
      //menu.textAlign(CENTER);
      menu.textFont(font);
      menu.textSize(16);
      menu.fill(255, 0, 0);
      menu.text(( (a.drawOrder == -1) ? "" : a.drawOrder )+"", 18, 29);
      menu.fill(0);
      menu.text(a.folderName, 40, 29);

      menu.translate(0, itemHeight);
    }
    menu.popMatrix();
    menu.popMatrix();
    menu.endDraw();
  }

  public void onMove() {
    updateMenu = true;
  }

  public void onEnter() {
    updateMenu = true;
  }

  void onLeave() {
    updateMenu = true;
  }

  public void onRelease() {
    int len = itemHeight * setImages.size();
    int index = int( map( getPointer().y() - pos, 0, len, 0, setImages.size() ) ) ;
    if (index < setImages.size() ) {
      ImageSet s = setImages.get(index);
      if ( getPointer().x() < w-50 ) {
        if (s.selected) {
          s.selected=false;
          GLOBAL_selectedSet =-1;
          GLOBAL_selectedAnchorImage=null;
          browser.updateSource(empty);
        } else {
          for (ImageSet a : setImages) {
            a.selected=false;
            s.selected=true;
          }
          GLOBAL_selectedSet = index;
          browser.updateSource(s.aImages);
          updateMenu = true;
        }
      } else {
        //dOrder.remove( setImages.indexOf(s) );
        setImages.remove(s);
        //updateDrawOrder();
        GLOBAL_selectedSet =-1;
        browser.updateSource(empty);
        resetDrawOrder();
      }
    }
    println(GLOBAL_selectedSet);
  }

  void deselectAll() {
    for (ImageSet a : setImages) {
      a.selected=false;
      GLOBAL_selectedSet =-1;
      GLOBAL_selectedAnchorImage=null;
      browser.updateSource(empty);
    }
  }

  public void onDrag() {
    npos += getPointer().dy() * 2;
    updateMenu = true;
  } 

  public void onScroll(int n) {
    npos -= ( n * 64 );
    updateMenu = true;
  }

  void updateHeight() {
    totalHeight = itemHeight * setImages.size();
  }
}
